%define tightvnc 1.2.2
Summary:   A remote display system.
Name:      vnc
Version:   3.3.3r2
Release: 25
URL:       http://www.uk.research.att.com/vnc/
Source0:   http://www.uk.research.att.com/vnc/dist/%{name}-%{version}_unixsrc.tgz
Source1:   vnc.conf
Source2:   vncserver.init
Source3:   vnc-latest_doc.tgz
Source4:   Xvnc.1
Source5:   vncserver.1
Source6:   vncpasswd.1
Source7:   vncconnect.1
Source8:   vncviewer.1
Source9:   http://prdownloads.sourceforge.net/vnc-tight/tightvnc-%{tightvnc}_javabin.tar.gz
Patch0:    http://prdownloads.sourceforge.net/vnc-tight/vnc-3.3.3r2-unix-tight-%{tightvnc}.patch.bz2
Patch1:    vnc-imake.patch
Patch2:    vnc-fp.patch
Patch3:    vnc-3.3.3r2-tcpwrappers.patch
Patch4:    vnc-xclients.patch
Patch5:    vnc-3.3.3r2-fsfd.patch
Patch6:    vnc-3.3.3r2-noman.patch
Patch7:    vnc-3.3.3r2-s390.patch
License:   GPL
Group:     User Interface/Desktops
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: /usr/bin/perl tcp_wrappers
BuildRequires: zlib-devel libjpeg-devel
Prereq:    /sbin/chkconfig /sbin/service
ExclusiveArch: i386 alpha sparc s390 s390x

%description
Virtual Network Computing (VNC) is a remote display system which
allows you to view a computing 'desktop' environment not only on the
machine where it is running, but from anywhere on the Internet and
from a wide variety of machine architectures.  This package contains a
client which will allow you to connect to other desktops running a VNC
server.

%package server
Summary: A VNC server.
Requires: XFree86 bash >= 2.0
Group: User Interface/X
Prereq: /sbin/chkconfig /etc/init.d

%description server
The VNC system allows you to access the same desktop from a wide
variety of platforms.  This package is a VNC server, allowing others
to access the desktop on your machine.

%package doc
Summary: Complete documentation for VNC.
Group: User Interface/Desktops

%description doc
This package contains HTML documentation about VNC (Virtual Network
Computing) programs.  Install the vnc-doc package if you want
extensive online documentation about VNC.

%prep
%setup -q -n %{name}_unixsrc -a 3

# Tight encoding
%patch0 -p1
gzip -dc %{SOURCE9} | tar xf -

%patch1 -p1 -b .imake

# Use the font server
%patch2 -p1 -b .fp

# Use tcp_wrappers
%patch3 -p1 -b .tcpwrappers

# Use xinit's Xclients script to start the session (bug #52711)
%patch4 -p1 -b .xclients

# Don't segfault when disconnecting from font server (bug #55135)
%patch5 -p1 -b .fsfd

# Fix for compilation with XFree86 4.1's xmkmf.
%patch6 -p1 -b .noman

# Add support for s390 and s390x architectures.
%patch7 -p1 -b .s390

find . -name "*,v" -exec rm -f {} \;
perl -pi -e "s|/usr/local/vnc/classes|%{_datadir}/vnc/classes|" vncserver

%build
xmkmf -a
make CDEBUGFLAGS="$RPM_OPT_FLAGS" World
cd Xvnc
make EXTRA_LIBRARIES="-lwrap -lnss_nis" CDEBUGFLAGS="$RPM_OPT_FLAGS" World

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_bindir}
./vncinstall %{buildroot}%{_bindir}
cd Xvnc
make DESTDIR="%{buildroot}" install
cd ..

mkdir -p %{buildroot}%{_datadir}/vnc
cp -aR classes %{buildroot}%{_datadir}/vnc

strip %{buildroot}%{_bindir}/* || :

mkdir -p %{buildroot}/etc/rc.d/init.d
install -m755 %{SOURCE2} %{buildroot}/etc/rc.d/init.d/vncserver

mkdir -p %{buildroot}%{_mandir}/man1
install -m644 %{SOURCE4} %{buildroot}%{_mandir}/man1
install -m644 %{SOURCE5} %{buildroot}%{_mandir}/man1
install -m644 %{SOURCE6} %{buildroot}%{_mandir}/man1
install -m644 %{SOURCE7} %{buildroot}%{_mandir}/man1
install -m644 %{SOURCE8} %{buildroot}%{_mandir}/man1

mkdir -p %{buildroot}/etc/sysconfig
cat > %{buildroot}/etc/sysconfig/vncservers << EOF
# The VNCSERVERS variable is a list of display:user pairs.
#
# Uncomment the line below to start a VNC server on display :1
# as my 'myusername' (adjust this to your own).  You will also
# need to set a VNC password; run 'man vncpasswd' to see how
# to do that.  
#
# DO NOT RUN THIS SERVICE if your local area network is
# untrusted!  For a secure way of using VNC, see
# <URL:http://www.uk.research.att.com/vnc/sshvnc.html>.

# VNCSERVERS="1:myusername"
EOF
chmod 644 %{buildroot}/etc/sysconfig/vncservers

mkdir -p %{buildroot}/etc/X11/applnk/Applications
cat > %{buildroot}/etc/X11/applnk/Applications/vncviewer.desktop << EOF
[Desktop Entry]
Name=VNC Viewer
Comment=VNC client application
Exec=/usr/bin/vncviewer
Terminal=0
Type=Application
EOF

%clean
rm -rf %{buildroot}

%post server
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add vncserver
fi

%preun server
if [ "$1" = 0 ]; then
  /sbin/service vncserver stop >/dev/null 2>&1
  /sbin/chkconfig --del vncserver
fi

%postun server
if [ "$1" -ge "1" ]; then
  /sbin/service vncserver condrestart >/dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc LICENCE.TXT README 
%{_bindir}/vncviewer
%config(noreplace) /etc/X11/applnk/Applications/vncviewer.desktop
%{_mandir}/man1/vncviewer.1*

%files server
%defattr(-,root,root)
%attr(0755,root,root) %config /etc/rc.d/init.d/vncserver
%config(noreplace) /etc/sysconfig/vncservers
%{_bindir}/Xvnc
%{_bindir}/vncserver
%{_bindir}/vncpasswd
%{_bindir}/vncconnect
%{_datadir}/vnc
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/vncconnect.1*
%{_mandir}/man1/vncpasswd.1*

%files doc
%defattr(-,root,root)
%doc vnc_docs/*

%changelog
* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Dec 05 2001 David Sainty <dsainty@redhat.com> 3.3.3r2-24
- Added support for s390 and s390x architectures.

* Thu Nov 29 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-23
- TightVNC 1.2.2.

* Mon Nov  5 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-22
- Don't use bash redirections except in bash (bug #55686).

* Fri Oct 26 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-21
- Run /etc/X11/xinit/xinitrc in xstartup, not Xclients (bug #52711).
- Don't segfault when disconnecting from font server (bug #55135).

* Wed Sep 26 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-20
- TightVNC 1.2.1, which incorporates several patches we had.

* Mon Sep  3 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-19
- Use xinit's Xclients script to start the session (bug #52711).
- Make vncpasswd create ~/.vnc if it doesn't exist (bug #52547).
- Mention the eight character password limit in vncpasswd.1.

* Tue Jul 24 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-18
- Build requires zlib-devel, libjpeg-devel (bug #49731).

* Fri Jul 13 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-17
- Rebuild to fix file ownership problems.

* Tue Jun  5 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-16
- Really fix bug #28318.
- Use tcp_wrappers (bug #41052).
- Fix build error when using XFree86 4.1.0's imakefile config.

* Fri May  4 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-15
- Add tight encoding patch (includes corre and typo patches).
- Const's Java viewer with tight encoding.
- Update man pages.
- Use the font server (bug #35913).

* Mon Feb 19 2001 Tim Waugh <twaugh@redhat.com> 3.3.3r2-14
- Make initscript change to user's home directory before starting
  vncserver (bug #28318).
- Make initscript stop properly.

* Thu Feb  8 2001 Tim Waugh <twaugh@redhat.com>
- Change initscript usage string.
- Resync descriptions and summaries to match those from specspo.

* Tue Jan 23 2001 Tim Waugh <twaugh@redhat.com>
- Redo initscript internationalisation.
- Initscript uses bash not sh.

* Fri Jan 19 2001 Tim Waugh <twaugh@redhat.com>
- Xvnc man page: put a pointer to tunnelling through ssh.

* Thu Jan 18 2001 Tim Waugh <twaugh@redhat.com>
- Warn about VNC being insecure in /etc/sysconfig/vncservers.
- CoRRE fix from Const Kaplinsky (bug #24285).

* Mon Jan 15 2001 Tim Waugh <twaugh@redhat.com>
- Initscript internationalisation.

* Tue Dec 12 2000 Tim Waugh <twaugh@redhat.com>
- Service is off by default (bug #22076).
- Don't start VNC server in initscript if user has not set passwd yet
  (bug #22076).

* Thu Dec 07 2000 Tim Waugh <twaugh@redhat.com>
- Mark vncviewer.desktop noreplace.
- Mark vncservers and /etc/rc.d/init.d/vncserver config.
- Add reload to vncserver initscript.
- chkconfig in post.

* Fri Dec 01 2000 Tim Waugh <twaugh@redhat.com>
- Rebuilt because of fileutils bug.

* Mon Nov 06 2000 Tim Waugh <twaugh@redhat.com>
- Include vncpasswd man page in manifest.

* Mon Nov 06 2000 Tim Waugh <twaugh@redhat.com>
- Add vncviewer.desktop.
- Correct typo in vncconnect.c.
- Add man pages.

* Mon Oct 30 2000 Tim Waugh <twaugh@redhat.com>
- set XAUTHORITY before running xstartup.  Fixes vncserver in ssh
  sessions.
- revamp initscript so that it allows for non-root users.

* Thu Oct 26 2000 Tim Waugh <twaugh@redhat.com>
- update to 3.3.3r2.  Patch from bug #19146 no longer needed.
- include new vncconnect program in file list

* Thu Oct 26 2000 Tim Waugh <twaugh@redhat.com>
- fix initscript (bug #19698)

* Tue Oct 17 2000 Than Ngo <than@redhat.com>
- fixed VNC crashes, patch from Shinji Hattori (Bug #10528)

* Mon Oct 16 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix authentication, Bug #19146, Patch from Tim Waugh <twaugh@redhat.com>

* Fri Aug  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Remove ,v file from vnc-doc, Bug #12443

* Thu Jul 20 2000 Bill Nottingham <notting@redhat.com>
- move initscript back

* Thu Jul 13 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Mon Jul 10 2000 Preston Brown <pbrown@redhat.com>
- move initscript

* Thu Jun 15 2000 Preston Brown <pbrown@redhat.com>
- move post/postun scripts from main package to server subpackage

* Mon Jun 12 2000 Preston Brown <pbrown@redhat.com>
- preun and postun sections

* Fri Jun 09 2000 Preston Brown <pbrown@redhat.com>
- initial package, from Sean P. Kane package and Mandrake package
- rewrote init script, added condrestart mode
